#ifndef FIFO_H
#define FIFO_H

#include <inttypes.h>

#include <avr/io.h>

#include <avr/interrupt.h>

#include <avr/signal.h>

#ifndef FIFO_C
	
	extern void FIFO_Init(void);
	
	extern unsigned char FIFO_Put(char ch);
	
	extern unsigned char FIFO_Get(char* ch);
	
	extern unsigned char FIFO_IsEmpty(void);
	
	extern unsigned char FIFO_IsFull(void);
	
#else

	#define 	  FIFO_SIZE 8	
	
	static unsigned char putI;
	
	static unsigned char getI;
	
	static unsigned char size;
	
	static char Fifo[FIFO_SIZE];
	
	void FIFO_Init(void);
	
	unsigned char FIFO_Put(char ch);
	
	unsigned char FIFO_Get(char* ch);
	
	unsigned char FIFO_IsEmpty(void);
	
	unsigned char FIFO_IsFull(void);

	
#endif

#endif
