#include <inttypes.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/signal.h>

#include "sio.h"
#include "fifo.h"

void SIO_init(void)
{
	UBRRH=(uint8_t)(UART_BAUD_CALC(UART_BAUD_RATE,F_CPU)>>8);
	UBRRL=(uint8_t)UART_BAUD_CALC(UART_BAUD_RATE,F_CPU);
	UCSRB |= ( 1 << RXEN );
	UCSRB |= ( 1 << RXCIE);
	UCSRB |= ( 1 << TXEN );
	UCSRC = (1<<URSEL)|(1<<USBS)|(3<<UCSZ0);
}

// Interrupts

SIGNAL(SIG_UART_RECV)
{
	char ch;
	ch = UDR;  
	FIFO_Put(ch);
}

void SIO_enableRX()
{
	UCSRB |= ( 1 << RXEN );
}

void SIO_enableTX()
{
	UCSRB |= ( 1 << TXEN );
}

unsigned char SIO_putChar(unsigned char ch) 
{
 	while (!(UCSRA & (1<<UDRE))); 
	UDR = ch; 
	return 0;
}

uint8_t SIO_getChar(void) 
{
	while (!(UCSRA & (1<<RXC)));
	return UDR; 
}

void SIO_putStr (char *s)
{
	while (*s)
	{ 
		SIO_putChar(*s);
		s++;
	}
}

